package com.lofiminds.gm
{
   import flash.display.Sprite;
   import flash.events.Event;
   import flash.events.KeyboardEvent;
   import flash.events.MouseEvent;
   import flash.media.Sound;
   import flash.media.SoundTransform;
   import flash.utils.getTimer;
   
   public class GameApplication extends Sprite
   {
       
      
      public var fpsCount:int = 0;
      
      public var soundFxTransform:SoundTransform;
      
      public var showFps:Boolean = false;
      
      public var showCollisionRects:Boolean = false;
      
      private var fpsTime:int = 0;
      
      private var fpsFrames:int = 0;
      
      public function GameApplication()
      {
         super();
         addEventListener(Event.ENTER_FRAME,run);
         addEventListener(Event.ADDED_TO_STAGE,onAddToStage);
         GameContext.app = this;
      }
      
      private function onAddToStage(param1:Event) : void
      {
         stage.addEventListener(KeyboardEvent.KEY_DOWN,GameInput.keyDownHandler);
         stage.addEventListener(KeyboardEvent.KEY_UP,GameInput.keyUpHandler);
         stage.addEventListener(MouseEvent.MOUSE_MOVE,GameInput.mouseMoveHandler);
         stage.addEventListener(MouseEvent.MOUSE_DOWN,GameInput.mouseDownHandler);
         stage.addEventListener(MouseEvent.MOUSE_UP,GameInput.mouseUpHandler);
         var _loc2_:GameRoom = createRoom();
         addChild(_loc2_);
         _loc2_.init();
         GameContext.room = _loc2_;
         this.onInit();
      }
      
      public function playSound(param1:Sound) : void
      {
         param1.play(0,0,this.soundFxTransform);
      }
      
      public function onInit() : void
      {
      }
      
      private function run(param1:Event) : void
      {
         Instances.updateGameObjects();
         Collisions.update();
         if(GameContext.room != null)
         {
            GameContext.room.repaint();
         }
         ++fpsFrames;
         var _loc2_:int = getTimer();
         if(_loc2_ - fpsTime > 1000)
         {
            fpsCount = fpsFrames / ((_loc2_ - fpsTime) / 1000);
            fpsFrames = 0;
            fpsTime = _loc2_;
         }
      }
      
      public function createRoom() : GameRoom
      {
         return new GameRoom();
      }
   }
}
