package com.lofiminds.gm
{
   import flash.display.Bitmap;
   import flash.display.BitmapData;
   import flash.display.Shape;
   import flash.display.Sprite;
   import flash.geom.ColorTransform;
   import flash.geom.Matrix;
   import flash.geom.Point;
   import flash.geom.Rectangle;
   import flash.text.TextField;
   import flash.text.TextFieldAutoSize;
   import flash.utils.getTimer;
   
   public class GameRoom extends Sprite
   {
       
      
      public var viewTopLeftX:int;
      
      public var viewTopLeftY:int;
      
      private var fpsText:TextField;
      
      private var bitmap:Bitmap;
      
      public var clearColor:uint;
      
      private var bitmapData:BitmapData;
      
      private var gameGraphics:GameGraphics;
      
      private var vectorShape:Shape;
      
      public function GameRoom()
      {
         fpsText = new TextField();
         super();
      }
      
      internal function repaint() : void
      {
         bitmapData.lock();
         bitmapData.fillRect(bitmapData.rect,this.clearColor);
         gameGraphics.clear();
         gameGraphics.setOffset(viewTopLeftX,viewTopLeftY);
         drawObjects();
         if(GameContext.app.showCollisionRects)
         {
            Collisions.drawCollisionBounds(gameGraphics);
         }
         if(GameContext.app.showFps)
         {
            drawFps();
         }
         vectorShape.visible = gameGraphics.hasVectorData;
         bitmapData.unlock();
      }
      
      public function init() : void
      {
         var _loc1_:int = this.stage.stageWidth;
         var _loc2_:int = this.stage.stageHeight;
         bitmapData = new BitmapData(_loc1_,_loc2_,false);
         bitmap = new Bitmap(bitmapData);
         this.addChild(bitmap);
         vectorShape = new Shape();
         vectorShape.width = _loc1_;
         vectorShape.height = _loc2_;
         vectorShape.scaleX = 1;
         vectorShape.scaleY = 1;
         this.addChild(vectorShape);
         gameGraphics = new GameGraphics(vectorShape.graphics,this.bitmapData);
      }
      
      private function drawFps() : void
      {
         fpsText.autoSize = TextFieldAutoSize.LEFT;
         fpsText.text = GameContext.app.fpsCount.toString();
         gameGraphics.drawObject(fpsText,8,8);
      }
      
      private function timerTest() : void
      {
         var _loc1_:int = 0;
         var _loc2_:int = 0;
         var _loc4_:ColorTransform = null;
         var _loc3_:Array = new Array();
         _loc1_ = 0;
         while(_loc1_ < 10000)
         {
            _loc3_.push(new ColorTransform());
            _loc1_++;
         }
         var _loc5_:BitmapData;
         (_loc5_ = new BitmapData(64,64)).fillRect(new Rectangle(10,10,16,16),16744576);
         var _loc6_:Matrix;
         (_loc6_ = new Matrix()).rotate(Math.PI / 4);
         _loc2_ = getTimer();
         _loc1_ = 0;
         while(_loc1_ < 10000)
         {
            bitmapData.draw(_loc5_,_loc6_,null,null,null,true);
            _loc1_++;
         }
         trace("time smooth true: " + (getTimer() - _loc2_));
         _loc2_ = getTimer();
         _loc1_ = 0;
         while(_loc1_ < 10000)
         {
            bitmapData.draw(_loc5_,_loc6_,null,null,null,false);
            _loc1_++;
         }
         trace("time smooth false: " + (getTimer() - _loc2_));
         _loc2_ = getTimer();
         _loc1_ = 0;
         while(_loc1_ < 10000)
         {
            bitmapData.draw(_loc5_,_loc6_,ColorTransform(_loc3_[_loc1_]),null,null,true);
            _loc1_++;
         }
         trace("time smooth+ct: " + (getTimer() - _loc2_));
      }
      
      private function drawObjects() : void
      {
         var _loc1_:GameObject = null;
         var _loc4_:Boolean = false;
         var _loc6_:BitmapData = null;
         var _loc7_:GameImage = null;
         var _loc9_:Array = null;
         var _loc10_:int = 0;
         var _loc11_:int = 0;
         var _loc2_:Point = new Point(0,0);
         var _loc3_:Array = Instances.getObjectsPerDepth();
         var _loc5_:Matrix = new Matrix();
         var _loc8_:int = 0;
         while(_loc8_ < _loc3_.length)
         {
            _loc10_ = int((_loc9_ = _loc3_[_loc8_] as Array).length);
            _loc11_ = 0;
            while(_loc11_ < _loc10_)
            {
               _loc1_ = _loc9_[_loc11_];
               _loc7_ = _loc1_.image;
               if(_loc1_.useCustomDraw)
               {
                  _loc4_ = _loc1_.onCustomDraw(gameGraphics);
               }
               else
               {
                  _loc4_ = true;
               }
               if(_loc4_ && _loc7_ != null)
               {
                  _loc6_ = _loc7_.getFrame(_loc1_.image_index);
                  _loc2_.x = _loc1_.x - viewTopLeftX - _loc7_.originX;
                  _loc2_.y = _loc1_.y - viewTopLeftY - _loc7_.originY;
                  if(_loc1_.image_angle == 0 && !_loc1_.hasColorTransform)
                  {
                     bitmapData.copyPixels(_loc6_,_loc6_.rect,_loc2_,null,null);
                  }
                  else
                  {
                     _loc5_.identity();
                     _loc5_.translate(-_loc7_.originX,-_loc7_.originY);
                     _loc5_.rotate(0 - _loc1_.image_angle);
                     _loc5_.translate(_loc7_.originX,_loc7_.originY);
                     _loc5_.translate(_loc2_.x,_loc2_.y);
                     bitmapData.draw(_loc6_,_loc5_,_loc1_.colorTransform,null,null,true);
                  }
               }
               _loc11_++;
            }
            _loc8_++;
         }
      }
   }
}
