package com.lofiminds.gm
{
   import flash.display.BitmapData;
   import flash.display.DisplayObject;
   import flash.geom.ColorTransform;
   
   public class GameUtil
   {
      
      private static var randSeed:uint = 1;
      
      private static var hsvCt:ColorTransform = new ColorTransform();
       
      
      public function GameUtil()
      {
         super();
      }
      
      public static function lengthdir_x(param1:Number, param2:Number) : Number
      {
         return Math.cos(param2) * param1;
      }
      
      public static function lengthdir_y(param1:Number, param2:Number) : Number
      {
         return Math.sin(0 - param2) * param1;
      }
      
      public static function random() : Number
      {
         randSeed = ((randSeed + 1) * 75 - 1) % 65537;
         return randSeed / 65537;
      }
      
      public static function point_distance(param1:Number, param2:Number, param3:Number, param4:Number) : Number
      {
         var _loc5_:Number = param3 - param1;
         var _loc6_:Number = param4 - param2;
         return Math.sqrt(_loc5_ * _loc5_ + _loc6_ * _loc6_);
      }
      
      public static function setRandomSeed(param1:uint) : void
      {
         randSeed = param1;
      }
      
      public static function make_color_rgb(param1:uint, param2:uint, param3:uint) : uint
      {
         return 255 << 24 | param1 << 16 | param2 << 8 | param3;
      }
      
      public static function setColorTransform(param1:uint, param2:ColorTransform) : void
      {
         var _loc3_:uint = uint(param1 >> 16 & 255);
         var _loc4_:uint = uint(param1 >> 8 & 255);
         var _loc5_:uint = uint(param1 & 255);
         param2.redMultiplier = _loc3_ / 255;
         param2.greenMultiplier = _loc4_ / 255;
         param2.blueMultiplier = _loc5_ / 255;
      }
      
      public static function frac(param1:Number) : Number
      {
         return param1 - Math.floor(param1);
      }
      
      public static function point_direction(param1:Number, param2:Number, param3:Number, param4:Number) : Number
      {
         var _loc5_:Number = param3 - param1;
         var _loc6_:Number = param4 - param2;
         return 0 - Math.atan2(_loc6_,_loc5_);
      }
      
      public static function randomize() : void
      {
         randSeed = Math.random() * uint.MAX_VALUE;
      }
      
      public static function mergeColor(param1:uint, param2:uint, param3:Number = 0.5) : uint
      {
         var _loc7_:uint = 0;
         var _loc8_:uint = 0;
         var _loc4_:Number = 1 - param3;
         var _loc5_:uint = 0;
         var _loc6_:int = 0;
         while(_loc6_ <= 16)
         {
            _loc7_ = uint(param1 >> _loc6_ & 255);
            _loc8_ = uint(param2 >> _loc6_ & 255);
            _loc5_ |= uint(Math.max(0,Math.min(255,_loc7_ * param3 + _loc8_ * _loc4_))) << _loc6_;
            _loc6_ += 8;
         }
         return _loc5_;
      }
      
      public static function displayToBitmap(param1:DisplayObject) : BitmapData
      {
         var _loc2_:BitmapData = new BitmapData(param1.width,param1.height,true,0);
         _loc2_.draw(param1);
         return _loc2_;
      }
      
      public static function degToRad(param1:Number) : Number
      {
         return param1 * 0.017453293;
      }
      
      public static function sign(param1:Number) : Number
      {
         return param1 > 0 ? 1 : (param1 < 0 ? -1 : 0);
      }
      
      public static function randomRange(param1:Number, param2:Number) : Number
      {
         return param1 + (2 * random() - 1) * param2;
      }
      
      public static function clamp(param1:Number, param2:Number, param3:Number) : Number
      {
         if(param1 < param2)
         {
            return param2;
         }
         if(param1 > param3)
         {
            return param3;
         }
         return param1;
      }
      
      public static function radToDeg(param1:Number) : Number
      {
         return param1 * 57.29577951;
      }
      
      public static function make_color_hsv(param1:Number, param2:Number, param3:Number) : uint
      {
         var _loc4_:Number = NaN;
         var _loc5_:Number = NaN;
         var _loc6_:Number = NaN;
         var _loc7_:Number = NaN;
         var _loc8_:Number = NaN;
         var _loc9_:Number = NaN;
         var _loc10_:Number = NaN;
         var _loc11_:int = 0;
         if(param2 == 0)
         {
            _loc8_ = _loc9_ = _loc10_ = param3;
         }
         else
         {
            param1 *= 1 / 60;
            _loc11_ = Math.floor(param1);
            _loc4_ = param1 - _loc11_;
            _loc5_ = param3 * (1 - param2);
            _loc6_ = param3 * (1 - param2 * _loc4_);
            _loc7_ = param3 * (1 - param2 * (1 - _loc4_));
            switch(_loc11_)
            {
               case 0:
                  _loc8_ = param3;
                  _loc9_ = _loc7_;
                  _loc10_ = _loc5_;
                  break;
               case 1:
                  _loc8_ = _loc6_;
                  _loc9_ = param3;
                  _loc10_ = _loc5_;
                  break;
               case 2:
                  _loc8_ = _loc5_;
                  _loc9_ = param3;
                  _loc10_ = _loc7_;
                  break;
               case 3:
                  _loc8_ = _loc5_;
                  _loc9_ = _loc6_;
                  _loc10_ = param3;
                  break;
               case 4:
                  _loc8_ = _loc7_;
                  _loc9_ = _loc5_;
                  _loc10_ = param3;
                  break;
               default:
                  _loc8_ = param3;
                  _loc9_ = _loc5_;
                  _loc10_ = _loc6_;
            }
         }
         hsvCt.redOffset = _loc8_ * 255;
         hsvCt.greenOffset = _loc9_ * 255;
         hsvCt.blueOffset = _loc10_ * 255;
         return hsvCt.color;
      }
   }
}
