package com.lofiminds.gm
{
   import flash.geom.Point;
   import flash.geom.Rectangle;
   import flash.utils.*;
   
   public final class Instances
   {
      
      private static var objectsPerDepth:Array = new Array();
      
      private static var allObjects:Array = new Array();
      
      private static var objects:Dictionary = new Dictionary();
       
      
      public function Instances()
      {
         super();
      }
      
      public static function exists(param1:Class) : Boolean
      {
         return objects[param1] != null;
      }
      
      public static function getObjectsPerDepth() : Array
      {
         return objectsPerDepth;
      }
      
      public static function destroyAll(param1:Class = null) : void
      {
         var _loc3_:int = 0;
         var _loc4_:int = 0;
         var _loc5_:GameObject = null;
         if(param1 == null)
         {
            while(_loc3_ < allObjects.length)
            {
               GameObject(allObjects[_loc3_]).destroy();
               _loc3_++;
            }
            allObjects.length = 0;
            objects = new Dictionary();
            return;
         }
         var _loc2_:Array = objects[param1];
         if(_loc2_ != null)
         {
            _loc4_ = 0;
            while(_loc4_ < _loc2_.length)
            {
               _loc5_ = GameObject(_loc2_[_loc4_]);
               swapRemove(allObjects,_loc5_);
               swapRemove(getDepthList(_loc5_.depth),_loc5_);
               _loc5_.destroy();
               _loc4_++;
            }
            _loc2_.length = 0;
            delete objects[param1];
         }
      }
      
      public static function destroy(param1:GameObject) : void
      {
         var _loc2_:Array = objects[param1.getClass()];
         if(_loc2_ == null)
         {
            trace("error \'a\' is null: " + param1.getClass().toString());
            return;
         }
         swapRemove(_loc2_,param1);
         swapRemove(allObjects,param1);
         swapRemove(getDepthList(param1.depth),param1);
         param1.destroy();
         if(_loc2_.length == 0)
         {
            delete objects[param1.getClass()];
         }
      }
      
      private static function getDepthList(param1:int) : Array
      {
         while(objectsPerDepth.length <= param1)
         {
            objectsPerDepth.push(new Array());
         }
         return objectsPerDepth[param1] as Array;
      }
      
      public static function findAt(param1:Class, param2:Number, param3:Number) : GameObject
      {
         var _loc8_:GameObject = null;
         var _loc4_:Array;
         if((_loc4_ = objects[param1] as Array) == null)
         {
            return null;
         }
         var _loc5_:Rectangle = new Rectangle();
         var _loc6_:Point = new Point(param2,param3);
         var _loc7_:int = 0;
         while(_loc7_ < _loc4_.length)
         {
            _loc8_ = _loc4_[_loc7_];
            _loc5_.x = _loc8_.x - _loc8_.image.originX;
            _loc5_.y = _loc8_.y - _loc8_.image.originY;
            _loc5_.width = _loc8_.image.boundsWidth;
            _loc5_.height = _loc8_.image.boundsHeight;
            if(_loc5_.containsPoint(_loc6_))
            {
               return _loc8_;
            }
            _loc7_++;
         }
         return null;
      }
      
      private static function getAllObjects() : Array
      {
         return allObjects;
      }
      
      internal static function getAllOfClass(param1:Class) : Array
      {
         return objects[param1] as Array;
      }
      
      private static function swapRemove(param1:Array, param2:Object) : void
      {
         var _loc4_:Object = null;
         var _loc3_:int = param1.indexOf(param2);
         if(_loc3_ == -1)
         {
            trace("swapremove failed");
            return;
         }
         if(_loc3_ == param1.length - 1)
         {
            param1.pop();
         }
         else
         {
            _loc4_ = param1.pop();
            param1[_loc3_] = _loc4_;
         }
      }
      
      internal static function updateGameObjects() : void
      {
         var _loc1_:GameObject = null;
         var _loc2_:Array = getAllObjects();
         var _loc3_:int = 0;
         while(_loc3_ < _loc2_.length)
         {
            _loc1_ = _loc2_[_loc3_];
            _loc1_.update();
            _loc3_++;
         }
      }
      
      public static function getFirst(param1:Class) : GameObject
      {
         return GameObject((objects[param1] as Array)[0]);
      }
      
      public static function create(param1:Class, param2:Number, param3:Number) : GameObject
      {
         var _loc4_:GameObject;
         (_loc4_ = new param1()).x = param2;
         _loc4_.y = param3;
         if(objects[param1] == null)
         {
            objects[param1] = new Array();
         }
         (objects[param1] as Array).push(_loc4_);
         allObjects.push(_loc4_);
         getDepthList(_loc4_.depth).push(_loc4_);
         if(_loc4_.image != null)
         {
            _loc4_.prepareCollisionData();
         }
         return _loc4_;
      }
   }
}
