package com.lofiminds.xwung
{
   import com.lofiminds.gm.GameContext;
   import com.lofiminds.gm.GameImage;
   import com.lofiminds.gm.GameObject;
   import com.lofiminds.gm.GameUtil;
   import com.lofiminds.gm.Instances;
   import flash.display.Bitmap;
   import flash.geom.ColorTransform;
   import flash.geom.Rectangle;
   
   public class BgPiece extends GameObject
   {
      
      private static var GxClass:Class = BgPiece_GxClass;
      
      private static var imageCache:Array = initImageCache();
      
      private static var gameImage:GameImage = new GameImage(Bitmap(new GxClass()).bitmapData);
       
      
      internal var dirAdd:Number = 0;
      
      private var outside:Rectangle;
      
      internal var dir:Number = 0;
      
      public function BgPiece()
      {
         setImage(gameImage);
         super();
         outside = GameContext.room.getRect(null);
         outside.inflate(50,50);
         this.image = imageCache[int(Math.random() * imageCache.length)];
      }
      
      private static function initImageCache() : Array
      {
         var _loc4_:uint = 0;
         var _loc1_:Array = new Array(10);
         var _loc2_:ColorTransform = new ColorTransform();
         var _loc3_:int = 0;
         while(_loc3_ < _loc1_.length)
         {
            _loc4_ = GameUtil.make_color_hsv(0,0.47,0.4 + _loc3_ * 0.02);
            GameUtil.setColorTransform(_loc4_,_loc2_);
            _loc1_[_loc3_] = gameImage.clone().colorTransform(_loc2_);
            _loc3_++;
         }
         return _loc1_;
      }
      
      override public function getClass() : Class
      {
         return BgPiece;
      }
      
      override public function update() : void
      {
         super.update();
         dir += dirAdd;
         if(dirAdd < -0.01)
         {
            dirAdd += 0.01;
         }
         else if(dirAdd > 0.01)
         {
            dirAdd -= 0.01;
         }
         else
         {
            dirAdd = 0;
         }
         var _loc1_:Number = GameUtil.degToRad(dir);
         this.setSpeedAndDirection(4,_loc1_);
         if(!outside.contains(x,y))
         {
            Instances.destroy(this);
         }
      }
   }
}
