package com.lofiminds.xwung
{
   import com.lofiminds.gm.GameContext;
   import com.lofiminds.gm.GameGraphics;
   import com.lofiminds.gm.GameImage;
   import com.lofiminds.gm.GameObject;
   import com.lofiminds.gm.GameUtil;
   import com.lofiminds.gm.Instances;
   import flash.display.Bitmap;
   
   public class Bosspart extends Bosspiece
   {
      
      private static var gameImage1:GameImage = new GameImage(Bitmap(new GxClass1()).bitmapData,48,48);
      
      internal static var gameImageFlipped:GameImage = gameImage1.clone().flipVertical();
      
      private static var GxClass1:Class = Bosspart_GxClass1;
       
      
      internal var exploded:Boolean = false;
      
      internal var boss:Boss;
      
      internal var childPart:Bosspart;
      
      internal var parentPart:Bosspart;
      
      public function Bosspart()
      {
         super();
         setImage(gameImage1);
         useCustomDraw = true;
         depth = 1;
         energy = 8;
      }
      
      override public function getClass() : Class
      {
         return Bosspart;
      }
      
      override public function update() : void
      {
         this.vspeed = boss.vspeed;
         image_blend = GameUtil.mergeColor(16777215,GameUtil.make_color_hsv(169,0.59,0.39 + Math.random() * 0.21),hurt);
         if(childPart != null && childPart.exploded)
         {
            childPart = null;
         }
         if(parentPart != null && parentPart.exploded)
         {
            parentPart = null;
         }
         super.update();
      }
      
      internal function createTurret(param1:int, param2:Number, param3:Number) : Bossturret
      {
         var _loc4_:Bossturret = null;
         (_loc4_ = Instances.create(Bossturret,x,y) as Bossturret).image_index = param1;
         _loc4_.image_angle = image_angle;
         _loc4_.reload = param2;
         _loc4_.boss = boss;
         _loc4_.turn = param3;
         return _loc4_;
      }
      
      override public function destroy() : void
      {
         var _loc2_:Number = NaN;
         var _loc5_:GameObject = null;
         exploded = true;
         var _loc1_:Gameplay = Instances.getFirst(Gameplay) as Gameplay;
         if(!_loc1_.isRestart)
         {
            _loc1_.giveScore(100,this);
            GameContext.app.playSound(Xwung.explodeSnd);
         }
         var _loc3_:int = _loc1_.isRestart ? 2 : int(3 + GameUtil.random() * 5);
         _loc2_ = Math.random() * Math.PI * 2;
         var _loc4_:int = 0;
         while(_loc4_ < _loc3_)
         {
            (_loc5_ = Instances.create(Explosion,x,y)).setSpeedAndDirection(4 + Math.random() * 12,_loc2_);
            _loc2_ += Math.PI * 2 / _loc3_;
            _loc4_++;
         }
         super.destroy();
      }
      
      override public function onCustomDraw(param1:GameGraphics) : Boolean
      {
         if(childPart != null)
         {
            param1.drawGameImage(this.image,image_index * 2 + 1,x,y,image_angle,colorTransform);
            param1.drawGameImage(childPart.image,image_index * 2 + 1,childPart.x,childPart.y,childPart.image_angle,colorTransform);
            param1.drawGameImage(this.image,image_index * 2,x,y,image_angle,colorTransform);
            param1.drawGameImage(childPart.image,image_index * 2,childPart.x,childPart.y,childPart.image_angle,colorTransform);
         }
         else if(parentPart == null)
         {
            param1.drawGameImage(this.image,image_index * 2 + 1,x,y,image_angle,colorTransform);
            param1.drawGameImage(this.image,image_index * 2,x,y,image_angle,colorTransform);
         }
         return false;
      }
   }
}
