package com.lofiminds.xwung
{
   import com.lofiminds.gm.GameContext;
   import com.lofiminds.gm.GameGraphics;
   import com.lofiminds.gm.GameImage;
   import com.lofiminds.gm.GameObject;
   import com.lofiminds.gm.GameUtil;
   import com.lofiminds.gm.Instances;
   import flash.display.Bitmap;
   
   public class Bossturret extends Bosspiece
   {
      
      private static var gameImage1:GameImage = new GameImage(Bitmap(new GxClass1()).bitmapData,32,32).setOrigin(5,16);
      
      private static var GxClass1:Class = Bossturret_GxClass1;
       
      
      internal var exploded:Boolean = false;
      
      internal var parentPart:Bossturret;
      
      internal var boss:Boss;
      
      internal var childPart:Bossturret;
      
      internal var reload:Number = 0;
      
      internal var turn:Number = 0;
      
      public function Bossturret()
      {
         super();
         setImage(gameImage1);
         useCustomDraw = true;
         depth = 3;
         energy = 8;
      }
      
      override public function getClass() : Class
      {
         return Bossturret;
      }
      
      override public function update() : void
      {
         var _loc1_:GameObject = null;
         var _loc2_:Number = NaN;
         var _loc3_:int = 0;
         if(boss != null)
         {
            this.vspeed = boss.vspeed;
         }
         if(reload > 0)
         {
            --reload;
         }
         else
         {
            reload = 240;
         }
         if(image_index == 0)
         {
            if(reload < 60)
            {
               image_angle += turn;
            }
            if(reload < 80 && GameUtil.frac(reload * 0.025) == 0)
            {
               _loc2_ = GameUtil.degToRad(-15);
               _loc3_ = 0;
               while(_loc3_ < 5)
               {
                  _loc1_ = Instances.create(Enemybullet,x + GameUtil.lengthdir_x(28,image_angle + _loc2_),y + GameUtil.lengthdir_y(28,image_angle + _loc2_));
                  _loc1_.setSpeedAndDirection(2,image_angle + _loc2_);
                  _loc2_ += GameUtil.degToRad(7.5);
                  _loc3_++;
               }
            }
         }
         if(image_index == 1)
         {
            if(reload < 90)
            {
               image_angle += turn;
               if(GameUtil.frac(reload * 0.1) == 0)
               {
                  _loc1_ = Instances.create(Enemybullet,x + GameUtil.lengthdir_x(36,image_angle),y + GameUtil.lengthdir_y(36,image_angle));
                  _loc1_.setSpeedAndDirection(2,image_angle);
                  _loc1_.image = Enemybullet.gameImage2;
                  _loc1_.image_angle = image_angle;
               }
            }
         }
         if(image_index == 2)
         {
            if(reload == 0)
            {
               _loc2_ = GameUtil.degToRad(-30);
               _loc3_ = 0;
               while(_loc3_ < 3)
               {
                  _loc1_ = Instances.create(Rocket,x + GameUtil.lengthdir_x(36,image_angle + _loc2_),y + GameUtil.lengthdir_y(36,image_angle + _loc2_));
                  _loc1_.setSpeedAndDirection(3,image_angle + _loc2_);
                  _loc2_ += GameUtil.degToRad(30);
                  _loc3_++;
               }
            }
         }
         image_blend = GameUtil.mergeColor(16777215,GameUtil.make_color_hsv(169,0.29,0.75 + Math.random() * 0.21),hurt);
         if(childPart != null && childPart.exploded)
         {
            childPart = null;
         }
         if(parentPart != null && parentPart.exploded)
         {
            parentPart = null;
         }
         super.update();
      }
      
      override public function onCustomDraw(param1:GameGraphics) : Boolean
      {
         if(childPart != null)
         {
            param1.drawGameImage(this.image,image_index * 2 + 1,x,y,image_angle,colorTransform);
            param1.drawGameImage(childPart.image,image_index * 2 + 1,childPart.x,childPart.y,childPart.image_angle,colorTransform);
            param1.drawGameImage(this.image,image_index * 2,x,y,image_angle,colorTransform);
            param1.drawGameImage(childPart.image,image_index * 2,childPart.x,childPart.y,childPart.image_angle,colorTransform);
         }
         else if(parentPart == null)
         {
            param1.drawGameImage(this.image,image_index * 2 + 1,x,y,image_angle,colorTransform);
            param1.drawGameImage(this.image,image_index * 2,x,y,image_angle,colorTransform);
         }
         return false;
      }
      
      override public function destroy() : void
      {
         var _loc2_:Number = NaN;
         var _loc5_:GameObject = null;
         exploded = true;
         var _loc1_:Gameplay = Instances.getFirst(Gameplay) as Gameplay;
         if(!_loc1_.isRestart)
         {
            _loc1_.giveScore(100,this);
            GameContext.app.playSound(Xwung.explodeSnd);
         }
         var _loc3_:int = _loc1_.isRestart ? 2 : int(3 + GameUtil.random() * 5);
         _loc2_ = Math.random() * Math.PI * 2;
         var _loc4_:int = 0;
         while(_loc4_ < _loc3_)
         {
            (_loc5_ = Instances.create(Explosion,x,y)).setSpeedAndDirection(4 + Math.random() * 12,_loc2_);
            _loc2_ += Math.PI * 2 / _loc3_;
            _loc4_++;
         }
         super.destroy();
      }
   }
}
