package com.lofiminds.xwung
{
   import com.lofiminds.gm.GameContext;
   import com.lofiminds.gm.GameImage;
   import com.lofiminds.gm.GameObject;
   import com.lofiminds.gm.Instances;
   import flash.display.Bitmap;
   import flash.geom.Rectangle;
   
   public class Debris extends GameObject
   {
      
      private static var gameImage:GameImage = new GameImage(Bitmap(new GxClass()).bitmapData);
      
      private static var GxClass:Class = Debris_GxClass;
       
      
      private var outside:Rectangle;
      
      private var isOutside:Boolean;
      
      private var life:int;
      
      public function Debris()
      {
         super();
         this.setImage(gameImage);
         depth = 1;
         outside = GameContext.room.getRect(null);
         var _loc1_:Gameplay = Instances.getFirst(Gameplay) as Gameplay;
         if(_loc1_.level < 2)
         {
            life = Math.round(10 + _loc1_.level * 60);
         }
         else
         {
            life = -1;
         }
      }
      
      override public function destroy() : void
      {
         if(!isOutside)
         {
            Instances.create(Blip,x,y);
         }
         super.destroy();
      }
      
      override public function getClass() : Class
      {
         return Debris;
      }
      
      override public function update() : void
      {
         super.update();
         image_angle += hspeed * 0.01;
         if(life > 0)
         {
            --life;
         }
         if(life == 0)
         {
            Instances.destroy(this);
         }
         if(!outside.contains(x,y))
         {
            this.isOutside = true;
            Instances.destroy(this);
         }
      }
   }
}
