package com.lofiminds.xwung
{
   import com.lofiminds.gm.GameGraphics;
   import com.lofiminds.gm.GameImage;
   import com.lofiminds.gm.GameObject;
   import com.lofiminds.gm.GameUtil;
   import com.lofiminds.gm.Instances;
   import flash.display.Bitmap;
   
   public class Enemy2 extends EnemyBase
   {
      
      private static var gameImage1:GameImage = new GameImage(Bitmap(new GxClass1()).bitmapData,48,48,32,32);
      
      private static var GxClass1:Class = Enemy2_GxClass1;
       
      
      private var propAngle:Number = 0;
      
      private var my_x:Number = 0;
      
      private var my_y:Number = 0;
      
      public function Enemy2()
      {
         this.setImage(gameImage1);
         depth = 1;
         useCustomDraw = true;
         super();
      }
      
      override public function getClass() : Class
      {
         return Enemy2;
      }
      
      override public function onCustomDraw(param1:GameGraphics) : Boolean
      {
         param1.drawGameImage(image,0,x,y,image_angle,this.colorTransform);
         param1.drawGameImage(image,1,x,y,propAngle);
         return false;
      }
      
      override public function update() : void
      {
         var _loc1_:GameObject = null;
         if(Instances.exists(Player))
         {
            _loc1_ = Instances.getFirst(Player);
            my_x = _loc1_.x;
            my_y = _loc1_.y;
         }
         else if(GameUtil.point_distance(x,y,my_x,my_x) < 40)
         {
            my_x = Math.random() * 640;
            my_y = Math.random() * 480;
         }
         image_angle = add_rotation(GameUtil.point_direction(x,y,my_x,my_y),image_angle);
         this.motionAdd(image_angle,0.1);
         if(this.getSpeed() > 2)
         {
            this.setSpeedAndDirection(2,this.getDirection());
         }
         image_blend = GameUtil.make_color_hsv(169,0.35,0.78 + Math.random() * 0.15);
         propAngle += 0.1;
         super.update();
      }
      
      override public function destroy() : void
      {
         super.destroy();
      }
      
      private function add_rotation(param1:Number, param2:Number) : Number
      {
         var _loc4_:Number = NaN;
         param1 = GameUtil.radToDeg(param1);
         param2 = GameUtil.radToDeg(param2);
         var _loc3_:Number = GameUtil.radToDeg(this.getDirection());
         if(Math.abs(param1 - _loc3_) > 2)
         {
            _loc4_ = param1;
            if(param2 - _loc4_ > 180)
            {
               _loc4_ = 360 + _loc4_;
            }
            if(_loc4_ - param2 > 180)
            {
               _loc4_ -= 360;
            }
            if(param2 > _loc4_)
            {
               param2 -= 3;
            }
            if(param2 < _loc4_)
            {
               param2 += 3;
            }
         }
         return GameUtil.degToRad(param2);
      }
   }
}
