package com.lofiminds.xwung
{
   import com.lofiminds.gm.GameImage;
   import com.lofiminds.gm.GameObject;
   import com.lofiminds.gm.GameUtil;
   import com.lofiminds.gm.Instances;
   import flash.display.Bitmap;
   
   public class Enemy3 extends EnemyBase
   {
      
      private static var gameImage1:GameImage = new GameImage(Bitmap(new GxClass1()).bitmapData,48,48,44,44);
      
      private static var GxClass1:Class = Enemy3_GxClass1;
       
      
      private var my_x:Number = 0;
      
      private var my_y:Number = 0;
      
      private var attack:Boolean = false;
      
      private var alarm:int = 240;
      
      private var lastDir:Number = 0;
      
      private var reload:int = 100;
      
      public function Enemy3()
      {
         this.setImage(gameImage1);
         depth = 1;
         my_x = Math.random() * 640;
         my_y = Math.random() * 480;
         super();
      }
      
      override public function getClass() : Class
      {
         return Enemy3;
      }
      
      override public function update() : void
      {
         var _loc1_:GameObject = null;
         var _loc2_:Number = NaN;
         var _loc3_:int = 0;
         if(alarm > 0)
         {
            if(--alarm == 0)
            {
               attack = true;
            }
         }
         if(Math.round(Math.random() * 200) == 2)
         {
            image_speed = 0.5;
         }
         if(this.getSpeed() > 0.1)
         {
            lastDir = this.getDirection();
         }
         if(!attack)
         {
            this.motionAdd(GameUtil.point_direction(x,y,my_x,my_y),0.1);
            if(GameUtil.point_distance(x,y,my_x,my_y) < 40)
            {
               my_x = Math.random() * 640;
               my_y = Math.random() * 480;
            }
            if(this.getSpeed() > 1)
            {
               this.setSpeedAndDirection(1,this.getDirection());
            }
         }
         else if(Math.abs(this.getSpeed()) > 0.1)
         {
            this.setSpeedAndDirection(this.getSpeed() - 0.1,lastDir);
         }
         else
         {
            if(reload > 0)
            {
               --reload;
            }
            else
            {
               _loc2_ = 0;
               _loc3_ = 0;
               while(_loc3_ < 8)
               {
                  _loc1_ = Instances.create(Debris,x,y);
                  _loc1_.setSpeedAndDirection(5,_loc2_);
                  _loc1_.image_angle = _loc2_;
                  _loc2_ += GameUtil.degToRad(45);
                  _loc3_++;
               }
               attack = false;
               reload = 100;
               alarm = 300;
            }
            this.setSpeedAndDirection(0,lastDir);
         }
         image_angle = lastDir;
         image_blend = GameUtil.make_color_hsv(169,0.35,0.78 + Math.random() * 0.15);
         super.update();
      }
      
      override public function destroy() : void
      {
         super.destroy();
      }
      
      override public function animationEnd() : void
      {
         image_speed = 0;
         super.animationEnd();
      }
   }
}
