package com.lofiminds.xwung
{
   import com.lofiminds.gm.GameContext;
   import com.lofiminds.gm.GameGraphics;
   import com.lofiminds.gm.GameImage;
   import com.lofiminds.gm.GameInput;
   import com.lofiminds.gm.GameObject;
   import com.lofiminds.gm.GameUtil;
   import com.lofiminds.gm.Instances;
   import flash.display.Bitmap;
   import flash.display.Sprite;
   import flash.events.MouseEvent;
   import flash.net.URLRequest;
   import flash.net.navigateToURL;
   import flash.text.TextField;
   import flash.text.TextFieldAutoSize;
   import flash.text.TextFormat;
   import flash.ui.Keyboard;
   import flash.ui.Mouse;
   import flash.utils.getTimer;
   
   public class Gameplay extends GameObject
   {
      
      private static var LofiGxClass:Class = Gameplay_LofiGxClass;
      
      private static var titleImage:GameImage = new GameImage(Bitmap(new GxClass()).bitmapData);
      
      private static var StartGxClass:Class = Gameplay_StartGxClass;
      
      private static var GxClass:Class = Gameplay_GxClass;
       
      
      private var bgUp:Boolean;
      
      private var scoreLabel:TextField;
      
      private var titleDraw:Number = 0;
      
      internal var isRestart:Boolean;
      
      private var dir1:Number = 0;
      
      private var combo:int;
      
      private var score:int;
      
      internal var level:Number = 0;
      
      private var scoreShake:Number = 0;
      
      private var bgDown:Boolean;
      
      private var dir2:Number = 0;
      
      internal var hasPowerup:Boolean;
      
      private var lofiSprite:Sprite;
      
      private var bgLeft:Boolean;
      
      private var titleAlpha:Number = 0;
      
      private var startSprite:Sprite;
      
      private var titleTxt1:TextField;
      
      private var comboTime:int;
      
      private var bgReload:int = 0;
      
      public function Gameplay()
      {
         super();
         GameInput.addKeyPressListener(Keyboard.ENTER,onEnterPressed);
         scoreLabel = new TextField();
         scoreLabel.defaultTextFormat = new TextFormat("_ScoreAndTitle",12,0);
         scoreLabel.embedFonts = true;
         scoreLabel.autoSize = TextFieldAutoSize.CENTER;
         scoreLabel.textColor = GameUtil.make_color_hsv(0,0,0.59);
         scoreLabel.text = "0 points";
         depth = 3;
         this.useCustomDraw = true;
      }
      
      final internal function giveScore(param1:int, param2:GameObject) : void
      {
         setScore(score + param1);
         if(scoreShake < 10)
         {
            scoreShake = 10;
         }
         combo += 1;
         comboTime = 60;
         var _loc3_:NumberDraw = Instances.create(NumberDraw,param2.x,param2.y) as NumberDraw;
         _loc3_.number = combo;
      }
      
      override public function update() : void
      {
         var _loc1_:Number = NaN;
         super.update();
         updateBackground();
         if(comboTime > 0)
         {
            --comboTime;
         }
         else
         {
            if(combo > 5)
            {
               Xwung.submitStatistic("Combo",combo);
               _loc1_ = 100;
               while(combo-- > 0)
               {
                  if(_loc1_ < 10000)
                  {
                     _loc1_ *= 1.3;
                  }
                  else
                  {
                     _loc1_ += 2500;
                  }
               }
               _loc1_ = Math.round(_loc1_ / 50 * 50);
               setScore(score + _loc1_);
               ComboDraw(Instances.create(ComboDraw,x,y)).value = _loc1_;
               scoreShake = 30;
            }
            combo = 0;
         }
      }
      
      private function setScore(param1:int) : void
      {
         score = param1;
         scoreLabel.text = score.toString() + " points";
      }
      
      private function updateBackground() : void
      {
         var _loc1_:BgPiece = null;
         if(GameContext.app.fpsCount < 50)
         {
            return;
         }
         if(int(Math.random() * 120) == 2)
         {
            bgLeft = false;
         }
         if(int(Math.random() * 120) == 2)
         {
            bgUp = false;
         }
         if(int(Math.random() * 120) == 2)
         {
            bgDown = false;
         }
         if(int(Math.random() * 180) == 2)
         {
            bgLeft = true;
         }
         if(int(Math.random() * 180) == 2)
         {
            bgUp = true;
         }
         if(int(Math.random() * 180) == 2)
         {
            bgDown = true;
         }
         if(bgReload > 0)
         {
            --bgReload;
         }
         else
         {
            bgReload = 10;
            if(bgLeft)
            {
               makeBg(0,180,dir1);
               makeBg(0,220,dir2);
               makeBg(0,260,-dir2);
               makeBg(0,300,-dir1);
               makeBg(640,180,-dir1,180);
               makeBg(640,220,-dir2,180);
               makeBg(640,260,dir2,180);
               makeBg(640,300,dir1,180);
            }
            makeBg(260,0,dir1,270);
            makeBg(300,0,dir2,270);
            makeBg(340,0,-dir2,270);
            makeBg(380,0,-dir1,270);
            if(bgDown)
            {
               makeBg(260,480,-dir1,90);
               makeBg(300,480,-dir2,90);
               makeBg(340,480,dir2,90);
               makeBg(380,480,dir1,90);
               dir1 += -0.5 + Math.random();
               dir2 += -0.5 + Math.random();
               dir1 = GameUtil.clamp(dir1,-5,5);
               dir2 = GameUtil.clamp(dir2,-5,5);
            }
         }
      }
      
      private function makeBg(param1:Number, param2:Number, param3:Number, param4:Number = 0) : void
      {
         var _loc5_:BgPiece = null;
         (_loc5_ = Instances.create(BgPiece,param1,param2) as BgPiece).dirAdd = param3;
         _loc5_.dir = param4;
      }
      
      override public function onCustomDraw(param1:GameGraphics) : Boolean
      {
         if(scoreShake > 0)
         {
            scoreShake -= 0.5;
         }
         param1.beginScreenSpace();
         param1.drawObject(scoreLabel,320 - scoreLabel.textWidth * 0.5 + scoreShake * GameUtil.randomRange(0,0.3),16 - scoreShake * GameUtil.randomRange(0,0.3));
         param1.endScreenSpace();
         drawTitleScreen(param1);
         return false;
      }
      
      private function drawTitleScreen(param1:GameGraphics) : void
      {
         var _loc2_:Bitmap = null;
         var _loc3_:Bitmap = null;
         if(Instances.exists(Player))
         {
            if(titleAlpha > 0)
            {
               titleAlpha -= 0.02;
            }
         }
         else if(titleAlpha < 1)
         {
            titleAlpha += 0.02;
         }
         if(titleAlpha <= 0.1)
         {
            return;
         }
         if(titleTxt1 == null)
         {
            titleTxt1 = new TextField();
            titleTxt1.defaultTextFormat = new TextFormat("_ScoreAndTitle",12,16711680);
            titleTxt1.autoSize = TextFieldAutoSize.LEFT;
            titleTxt1.embedFonts = true;
            _loc2_ = Bitmap(new StartGxClass());
            startSprite = new Sprite();
            startSprite.x = 320 - _loc2_.bitmapData.width / 2;
            startSprite.y = 300;
            startSprite.addEventListener(MouseEvent.CLICK,onEnterPressed);
            startSprite.addChild(_loc2_);
            GameContext.app.addChild(startSprite);
            _loc3_ = Bitmap(new LofiGxClass());
            lofiSprite = new Sprite();
            lofiSprite.x = 320 - _loc3_.bitmapData.width / 2;
            lofiSprite.y = 420;
            lofiSprite.addEventListener(MouseEvent.CLICK,onLofiClicked);
            lofiSprite.addChild(_loc3_);
            GameContext.app.addChild(lofiSprite);
         }
         this.colorTransform.alphaMultiplier = titleAlpha;
         titleTxt1.transform.colorTransform.alphaMultiplier = titleAlpha;
         startSprite.alpha = titleAlpha;
         lofiSprite.alpha = titleAlpha;
         if(titleDraw > 0)
         {
            titleDraw -= 0.01;
         }
         else
         {
            titleDraw = 4.99;
         }
         startSprite.y = 300 + Math.sin(0.0025 * getTimer()) * 4 + Math.cos(0.0008 * getTimer()) * 6;
         switch(Math.floor(titleDraw))
         {
            case 4:
               titleTxt1.text = "LAST SCORE: " + score;
               break;
            case 3:
               titleTxt1.text = "PRESS ENTER TO START";
               break;
            case 2:
               titleTxt1.text = "GAME BY CACTUS";
               break;
            case 1:
               titleTxt1.text = "FLASH VERSION BY VILLE";
               break;
            case 0:
               titleTxt1.text = "LO-FI MINDS";
         }
         param1.drawObject(titleTxt1,320 - titleTxt1.width / 2,240);
         param1.drawGameImage(titleImage,0,320,190,0,this.colorTransform);
      }
      
      private function onEnterPressed(param1:Object) : void
      {
         if(!Instances.exists(Player))
         {
            newGame();
         }
      }
      
      private function onLofiClicked(param1:Object) : void
      {
         var _loc2_:URLRequest = new URLRequest("http://www.lofiminds.com");
         navigateToURL(_loc2_,"_blank");
      }
      
      private function newGame() : void
      {
         isRestart = true;
         Instances.destroyAll(Enemy1);
         Instances.destroyAll(Enemy2);
         Instances.destroyAll(Enemy3);
         Instances.destroyAll(Bosspart);
         Instances.destroyAll(Bossturret);
         Instances.destroyAll(Boss);
         Instances.destroyAll(Enemybullet);
         Instances.destroyAll(Rocket);
         Instances.destroyAll(Bonus);
         isRestart = false;
         Mouse.hide();
         startSprite.visible = false;
         lofiSprite.visible = false;
         Instances.create(Player,300,300);
         Instances.create(Sledge,300,300);
         setScore(0);
         hasPowerup = false;
      }
      
      override public function destroy() : void
      {
         GameInput.removeKeyPressListener(Keyboard.ENTER,onEnterPressed);
         super.destroy();
      }
      
      internal function onGameOver() : void
      {
         startSprite.visible = true;
         lofiSprite.visible = true;
         Xwung.submitScore(score);
      }
   }
}
