package com.lofiminds.xwung
{
   import com.kongregate.as3.client.KongregateAPI;
   import com.lofiminds.gm.Collisions;
   import com.lofiminds.gm.GameApplication;
   import com.lofiminds.gm.GameRoom;
   import com.lofiminds.gm.Instances;
   import flash.events.Event;
   import flash.events.IOErrorEvent;
   import flash.events.ProgressEvent;
   import flash.media.Sound;
   import flash.media.SoundTransform;
   import flash.net.URLRequest;
   
   public dynamic class Xwung extends GameApplication
   {
      
      private static var snd1Class:Class = Xwung_snd1Class;
      
      public static var _font1:Class = Xwung__font1;
      
      public static var _font2:Class = Xwung__font2;
      
      internal static var explodeSnd:Sound = Sound(new snd1Class());
       
      
      private var music:Sound;
      
      public function Xwung()
      {
         super();
         Collisions.registerGroup(Player,Enemy1);
         Collisions.registerGroup(Player,Enemy2);
         Collisions.registerGroup(Player,Enemy3);
         Collisions.registerGroup(Player,Debris);
         Collisions.registerGroup(Player,Bonus);
         Collisions.registerGroup(Sledge,Bosspart);
         Collisions.registerGroup(Sledge,Bossturret);
         Collisions.registerGroup(Hitbox,Enemybullet);
         Collisions.registerGroup(Hitbox,Bosspart);
         Collisions.registerGroup(Hitbox,Bossturret);
         Collisions.registerGroup(Hitbox,Rocket);
         this.showFps = true;
         this.soundFxTransform = new SoundTransform(0.3,0);
      }
      
      internal static function submitStatistic(param1:String, param2:int) : void
      {
         kongregate.stats.submit(param1,param2);
      }
      
      internal static function submitScore(param1:int) : void
      {
         kongregate.scores.submit(param1);
         kongregate.stats.submit("HighScore",param1);
      }
      
      override public function onInit() : void
      {
         loadMusic();
         Instances.create(Gameplay,50,50);
         kongregate = new KongregateAPI();
         this.addChild(kongregate);
      }
      
      override public function createRoom() : GameRoom
      {
         var _loc1_:GameRoom = super.createRoom();
         _loc1_.clearColor = 4474424;
         return _loc1_;
      }
      
      private function onMusicLoadProgress(param1:ProgressEvent) : void
      {
         var _loc2_:uint = Math.round(100 * (param1.bytesLoaded / param1.bytesTotal));
         if(_loc2_ > 15)
         {
            music.removeEventListener(ProgressEvent.PROGRESS,onMusicLoadProgress);
            music.removeEventListener(Event.COMPLETE,onMusicLoadComplete);
            onMusicLoadComplete(null);
         }
      }
      
      private function onMusicLoadError(param1:Event) : void
      {
         trace("music load error: " + param1.toString());
      }
      
      private function onMusicLoadComplete(param1:Event) : void
      {
         music.play(0,9999);
      }
      
      private function loadMusic() : void
      {
         var _loc1_:String = this.root.loaderInfo.loaderURL;
         if(_loc1_ == null)
         {
            return;
         }
         _loc1_ = _loc1_.substring(0,_loc1_.lastIndexOf("/") + 1);
         music = new Sound();
         music.addEventListener(ProgressEvent.PROGRESS,onMusicLoadProgress);
         music.addEventListener(Event.COMPLETE,onMusicLoadComplete);
         music.addEventListener(IOErrorEvent.IO_ERROR,onMusicLoadError);
         var _loc2_:* = _loc1_ + "xwung_music1.mp3";
         trace("loading music...");
         music.load(new URLRequest(_loc2_));
      }
   }
}
